function [cl,RA,count]=labelswitching(A,Ki,verb,cli)
A=sparse(double(A));
N=size(A,1);
self=diag(A);
iclold=0;
icl=0;

if (nargin<3)
    verb=0;
end

if (nargin<4)
    initcount=ones(1,N);
    if Ki==N
        cl=(1:N)';
        count=ones(1,N);
        RA=A;
        K=N;
    else
        
        perm=randperm(N);
        seeds=perm(1:Ki);
        cl=zeros(N,1);
        cl(seeds)=1:Ki;
        count=ones(1,Ki);
        for j=(Ki+1):N;
            d1=sum(abs(repmat(A(perm(j),:),Ki,1)-A(seeds,:)),2);
            d2=sum(abs(repmat(A(:,perm(j)),1,Ki)-A(:,seeds)));
            d=d1+d2';
            [t,ord]=sort(d);
            iok=find(count(ord)<(N/Ki));
            ncl=ord(iok(1));
            cl(perm(j))=ncl;
            count(ncl)=count(ncl)+1;
        end
        
    end
else
    cl=cli;
end
if Ki==N && nargin<3
    RA=A;
    K=N;
else
    
    RA=zeros(max(cl));
    [i,j,s]=find(A);
    
    for t=1:length(i)
        RA(cl(i(t)),cl(j(t)))=RA(cl(i(t)),cl(j(t)))+1;
    end
    
    
    count=gsum(ones(size(cl)),cl);
    
    K=length(count);
end
hasMoved=1;
while hasMoved==1
    pass=randperm(N);
    hasMoved=0;
    nbmove=0;
    for i=1:N
        cnode=pass(i);
        classsumrow=gsum(A(cnode,:),cl);
        classsumcol=gsum(A(:,cnode),cl);
        deltaICL=cdeltaicl(RA,cl(cnode),count,classsumrow,classsumcol,self(cnode),N);
        [dicl,ncl]=max(deltaICL);
        if(dicl>0)
            RA=updateRA(RA,cl(cnode),ncl,classsumrow,classsumcol,self(cnode));
            count=updateCount(count,cl(cnode),ncl);
            oldcl=cl(cnode);
            cl(cnode)=ncl;
            if(count(oldcl)==0)
                count(oldcl)=[];
                cl(cl>oldcl)=cl(cl>oldcl)-1;
                RA(oldcl,:)=[];
                RA(:,oldcl)=[];
                K=K-1;
            end
            
            
            
            iclold=icl;
            icl=ICL(RA,count);
            sc=sort(count,'descend');
            if verb==1
                if length(sc)>8
                    disp(['MOVE, delta ICL :' num2str(dicl) ,' ',num2str(icl-iclold),' K : ' num2str(K) ,', countmax :' num2str(sc(1:3)), ' ... ' num2str(sc((end-3):end))]);
                else
                    disp(['MOVE, delta ICL :' num2str(dicl) ,' K : ' num2str(K) ,', countmax :' num2str(sc)]);
                end
            end
            hasMoved=1;
            nbmove=nbmove+1;
        end
        
    end
    disp(['Pass completed, number of move :',num2str(nbmove), '/' num2str(N)])
end

end
